<?php
include("Dbase.php");
// Users is connecting to Database
class Users extends Dbase{
    protected function getUsers($name){
        $sql = "SELECT * FROM users WHERE username = ? ";
        $stmt = $this->connect()->prepare($sql);
        $stmt->execute([$name]);
        $result = $stmt->fetchAll();
        return $result;
    }
    
    // INSERTING REGISTRATION TO DATABASE FOR NEW USERS
    
    protected function setUsers($name, $password, $email){
        $sql = "INSERT INTO users(username, password, email)VALUES(?, ?, ?)";
        $stmt = $this->connect()->prepare($sql);
        $stmt->execute([$name,$password,$email]);
    }
    
    // INSERTING CODE CONFIRMATION 
    
     protected function setcode($email, $code, $time, $expire, $reset_id){
        $sql = "INSERT INTO password_reset(email, code, status, code_time, expire_time, reset_id)VALUES(?, ?, ?, ?, ?, ?)";
        $stmt = $this->connect()->prepare($sql);
        $stmt->execute([$email, $code, "active", $time, $expire, $reset_id]);
    }
    
    //CHECKING IF NAME OR EMAIL EXIST
    protected function Registration($email, $user){
        $sql ="SELECT * FROM users WHERE email = ? || username = ?";
         $stmt = $this->connect()->prepare($sql);
         $stmt->execute([$email, $user]);
           $res = $stmt->rowCount();
           return $res;
    }
    
    // CHECKING IF USERNAME AND PASSWORD EXIST
   protected function Login($username, $password){
       $sql ="SELECT * FROM users WHERE username =? && password =?";
       $stmt = $this->connect()->prepare($sql);
       $stmt->execute([$username, $password]);
         $res = $stmt->rowCount();
           return $res;
       
   }
   
    // CHECKING IF USERNAME AND PASSWORD EXIST
   protected function regnew($user, $email){
       $sql ="SELECT * FROM client WHERE username =? || email =?";
       $stmt = $this->connect()->prepare($sql);
       $stmt->execute([$user, $email]);
         $res = $stmt->rowCount();
           return $res;
       
   }
   
   
   
   //CHECK IF EMAIL EXIST
    protected function ForgotPassword($email){
       $sql ="SELECT * FROM users WHERE email =?";
       $stmt = $this->connect()->prepare($sql);
       $stmt->execute([$email]);
         $res = $stmt->rowCount();
           return $res;
       
   }
   
  //CHECKING RESET CODE FROM DATABASE
  public function verifyCode($code){
      $sql ="SELECT code FROM password_reset WHERE code=? && status=?";
      $stmt = $this->connect()->prepare($sql);
      $stmt->execute([$code, "active"]);
       $res = $stmt->rowCount();
           return $res;
  }
  
 
 
  // UPDATE NEW PASSWORD TO DATABASE FOR OLD USERS
    protected function resetId($reset_id, $email){
        $sql = "UPDATE users SET password= ? WHERE reset_id =?";
        $stmt = $this->connect()->prepare($sql);
        $stmt->execute([$reset_id,$email]);
    }
    
  
  // GETTING RESET ID TO VERIFY THE PASSWORD
  protected function PasswordId($reset_id, $email){
        $sql = "UPDATE users SET reset_id= ? WHERE email =?";
        $stmt = $this->connect()->prepare($sql);
        $stmt->execute([$reset_id,$email]);
    }
    
  protected function passwordReset($pass, $resetId){
      $sql ="UPDATE users WHERE SET password= ? WHERE reset_id =?";
      $stmt = $this->connect()->prepare($sql);
      $stmt->execute([$pass, $resetid]);
  }
  
  //UPDATING USERS TABLE RESET ID COLUMN
   protected function usersReset($reset_id, $email){
        $sql = "UPDATE users SET reset_id= ? WHERE email =?";
        $stmt = $this->connect()->prepare($sql);
        $stmt->execute([$reset_id, $email]);
    }
    
    
    protected function getdetails(){
        $sql = "SELECT * FROM users";
        $stmt = $this->connect()->prepare($sql);
        $stmt->execute([]);
        $result = $stmt->fetchAll();
        return $result;
    }
    
     //OTP ACTIVATION
     protected function otp($user, $pass){
       $sql ="SELECT * FROM client WHERE username =? && pass =? && act_otp!=?";
       $stmt = $this->connect()->prepare($sql);
       $stmt->execute([$user, $pass, '']);
         $res = $stmt->rowCount();
           return $res;
       
   }
}